path1 = '../raw_data/jumpingjacks/frames_with_virtual_markers/';
path2 = '*.png';
files = dir([path1 path2]);

rup = [256 230 210 175 115 , 10 10 10 , 10 10 10 , 256 225 175 115, 256 225 175 115];
rlo = [235 215 190 135 85 , -1 -1 -1 , -1 -1 -1 , 235 190 135 85, 235 190 135 85];
gup = [10 10 10 10 10 , 256 225 175 , 10 10 10 , 256 225 175 115, 10 10 10 10];
glo = [-1 -1 -1 -1 -1 , 230 190 135 , -1 -1 -1 , 235 190 135 85, -1 -1 -1 -1];
bup = [10 10 10 10 10 , 10 10 10 , 256 225 175 , 10 10 10 10, 256 225 175 115];
blo = [-1 -1 -1 -1 -1 , -1 -1 -1 , 235 190 135 , -1 -1 -1 -1, 235 190 135 85];

for fctr=1:size(files,1)
    disp(fctr);
    imname = [path1 files(fctr).name];
    i1 = imread(imname);
    r = i1(:,:,1); g = i1(:,:,2); b = i1(:,:,3);
    imdots = [];

    for ctr=1:19
        
        disp(ctr);
        bodypart = (r<rup(ctr) & r>rlo(ctr)) & (g<gup(ctr) & g>glo(ctr)) & (b<bup(ctr) & b>blo(ctr));
        %----
        % find largest connected component - to correct for brush color errors
        [L,num] = bwlabel(bodypart);
        szcc=[];
        for i=1:num
            szcc(i) = length(find(L==i));
        end
        [szval,whichcomp] = max(szcc);
        [i,j] = find(L==whichcomp);
        %----        
        if(numel(i)==0)
            keyboard;
        end
        imdots = [imdots, mean(j), mean(i)];
    end
    balletinv(fctr,:) = imdots;
    balletinv(fctr,2:2:end) = 1080 - imdots(2:2:end);
end