% Notation: bRa rotates a vector expressed in the coordinate frame A to a
% vector expressed in the coordinate frame B.
% ja = hierarchical joint angles for the given marker positions.
% zyxlist = angles in the zyx ordering for each limb segment (I used this for
% debugging, can be ignored now)
function [ja, zyxlist] = getja(markerpositions, nearestja, prevja, prevzyxlist, dotsHome, Rzo, skeleton, N)

[pelR,pelangles] = estimatePelvisRotation(markerpositions,dotsHome,skeleton,N);
wRpelvis = pelR;
ja = zeros(1,length(nearestja));

rzoctr=1;
for chainctr=1:length(skeleton.kinematicchain)
    wRp = wRpelvis;
    kc = skeleton.kinematicchain{chainctr};
    jac = skeleton.jachain{chainctr};
    
    for linkctr = 1:length(kc)-1

        mpA(1,:) = markerpositions(1, (kc(linkctr)-1)*3+1:(kc(linkctr)-1)*3+3 ); % inner marker
        mpB(1,:) = markerpositions(1, (kc(linkctr+1)-1)*3+1:(kc(linkctr+1)-1)*3+3 ); % outer marker
        [newjaxyz, newjazyx] = getangles_useyaw3(  mpA, mpB, wRp, Rzo{rzoctr}, [nearestja(jac(linkctr):jac(linkctr)+2)],...
                                            prevja(jac(linkctr):jac(linkctr)+2), prevzyxlist(jac(linkctr):jac(linkctr)+2) );
        ja(jac(linkctr):jac(linkctr)+2) = newjaxyz;
        zyxlist(jac(linkctr):jac(linkctr)+2) = newjazyx;
        wRp = wRp * getRxyz(newjaxyz(1),newjaxyz(2),newjaxyz(3));
        rzoctr = rzoctr + 1;
    end % link
    
end % chain

ja(skeleton.PELVISja:skeleton.PELVISja+2) = pelangles;
% since we don't have virtual markers for the toes in the hand-drawings, we
% pick up toe angles from the motion capture data as well.
ja(skeleton.LTOESja:skeleton.LTOESja+2) = nearestja(skeleton.LTOESja:skeleton.LTOESja+2);
ja(skeleton.RTOESja:skeleton.RTOESja+2) = nearestja(skeleton.RTOESja:skeleton.RTOESja+2);

