% Rotate each limb segment (and the limb segments linked to it) so as to
% match the in-plane angle for the target hand-drawn frame.

function [match] = makematch(target,candidate,linkchain, pivot, point, skeleton)

match = candidate;
for i= 1:length(pivot)  
    thetat = circleangle( target(1, (pivot(i)-1)*2+1:(pivot(i)-1)*2+2), target((point(i)-1)*2+1:(point(i)-1)*2+2) );
    theta = circleangle( match(1, (pivot(i)-1)*2+1:(pivot(i)-1)*2+2), match((point(i)-1)*2+1:(point(i)-1)*2+2) );
    angle = thetat - theta;
    R = getRxyz(0,0,angle);
    match = rotateinplane(pivot(i), point(i), match, linkchain, R, skeleton);
end % i