% h = home position, 3xN
% p = current position, 3xN

function [R] = procrustesrotation(h,p)

if(size(h,2) ~= size(p,2))
    disp('insufficient input.'); keyboard;
end

A = [];
for i = 1:size(h,2),
    A = [A; [h(1:3,i)' 0 0 0 0 0 0; 0 0 0 h(1:3,i)' 0 0 0; 0 0 0 0 0 0 h(1:3,i)' ]];
end

r = A\p(:);

Rfull = [r(1:3)'; r(4:6)'; r(7:9)'];

[U,D,V] = svd(Rfull);
R = U*V(:,1:3)';