% x3drecon = reconstructed marker positions in 3D = numFrames x (3*N) 
% x2d = marker positions from image = numFrames x (2*numMarkers)
% camMatrix = 3x3 rotation matrix (orthographic projection)
% c = PCA basis
% m3d = mean of data
% weightll = weight of limb length constraints
% linpoint = point about which to linearize limb lengths

function [x3drecon] = reconstructMarkers3D(x2d, camMatrix, c, m3d, weightll, limblengths, ...
    linpoint, weightreg, regpoint, skeleton)

NCOMP = size(c,2);
numDots = size(x2d,2)/2;

[Aim,Bim] = getlinearsystem_imagematch(camMatrix, numDots,x2d,c,m3d);
[All,Bll] = limblengthlinearize(linpoint, limblengths, skeleton, c,m3d);
[Areg,Breg] = getregularization(regpoint,c,m3d);
A = [Aim; All; Areg];
b = [Bim; Bll; Breg];
W = eye(size(A,1));
W( size(Aim,1)+1:size(Aim,1)+size(All,1), size(Aim,1)+1:size(Aim,1)+size(All,1) ) = eye(size(All,1)) * weightll;

weightmatrixreg = setweightsreg( size(Areg,1), weightreg, skeleton);
W( size(Aim,1)+size(All,1)+1:end, size(Aim,1)+size(All,1)+1:end ) = weightmatrixreg;

% The final linear system is W*A*x = b (see Section 3.5, Equation 16).
xPCrecon = inv(A'*W*A)*(A'*W)*b;
x3drecon = xPCrecon' * c' + m3d;

