skeleton = struct;
load H24
skeleton.H = H;
skeleton.N = 24;
skeleton.linkchain = zeros(skeleton.N+2,skeleton.N+2);
% dot ordering
skeleton.HEAD = 1;
skeleton.NECK = 2;
skeleton.BASENECK = 3;
skeleton.UPPERBACK = 4;
skeleton.LOWERBACK = 5;
skeleton.PELVIS = 6;
skeleton.UPPERARMR = 7;
skeleton.LOWERARMR = 8;
skeleton.HANDR = 9;
skeleton.FINGERTIPSR = 10;
skeleton.UPPERARML = 11;
skeleton.LOWERARML = 12;
skeleton.HANDL = 13;
skeleton.FINGERTIPSL = 14;
skeleton.UPPERLEGR = 15;
skeleton.LOWERLEGR = 16;
skeleton.FOOTR = 17;
skeleton.TOESR = 18;
skeleton.TOETIPSR = 19;
skeleton.UPPERLEGL = 20;
skeleton.LOWERLEGL = 21;
skeleton.FOOTL = 22;
skeleton.TOESL = 23;
skeleton.TOETIPSL = 24;
skeleton.BASENECKCL = 25;
skeleton.BASENECKCR = 26;
%--------------------------------------------------------
skeleton.linkchain(skeleton.NECK,skeleton.HEAD) = 1;
skeleton.linkchain(skeleton.BASENECK, [skeleton.NECK skeleton.HEAD]) = 1;
skeleton.linkchain(skeleton.BASENECKCL, [skeleton.UPPERARML skeleton.LOWERARML skeleton.HANDL skeleton.FINGERTIPSL]) = 1;
skeleton.linkchain(skeleton.BASENECKCR, [skeleton.UPPERARMR skeleton.LOWERARMR skeleton.HANDR skeleton.FINGERTIPSR]) = 1;

skeleton.linkchain(skeleton.UPPERBACK,[skeleton.BASENECK skeleton.NECK skeleton.HEAD ...
            skeleton.UPPERARMR skeleton.LOWERARMR skeleton.HANDR skeleton.FINGERTIPSR ...
            skeleton.UPPERARML skeleton.LOWERARML skeleton.HANDL skeleton.FINGERTIPSL ]) = 1;
        
skeleton.linkchain(skeleton.LOWERBACK, [skeleton.UPPERBACK skeleton.BASENECK skeleton.NECK skeleton.HEAD ...
            skeleton.UPPERARMR skeleton.LOWERARMR skeleton.HANDR skeleton.FINGERTIPSR ...
            skeleton.UPPERARML skeleton.LOWERARML skeleton.HANDL skeleton.FINGERTIPSL ]) = 1;
        
skeleton.linkchain(skeleton.PELVIS, :) = 1;
skeleton.linkchain(skeleton.UPPERARMR, [skeleton.LOWERARMR skeleton.HANDR skeleton.FINGERTIPSR ]) = 1;
skeleton.linkchain(skeleton.LOWERARMR, [skeleton.HANDR skeleton.FINGERTIPSR]) = 1;
skeleton.linkchain(skeleton.HANDR , [skeleton.FINGERTIPSR]) = 1;

skeleton.linkchain(skeleton.UPPERARML, [skeleton.LOWERARML skeleton.HANDL skeleton.FINGERTIPSL ]) = 1;
skeleton.linkchain(skeleton.LOWERARML, [skeleton.HANDL skeleton.FINGERTIPSL ]) = 1;
skeleton.linkchain(skeleton.HANDL , [skeleton.FINGERTIPSL]) = 1;

skeleton.linkchain(skeleton.UPPERLEGR, [skeleton.LOWERLEGR skeleton.FOOTR skeleton.TOESR skeleton.TOETIPSR]) = 1;
skeleton.linkchain(skeleton.LOWERLEGR, [skeleton.FOOTR skeleton.TOESR skeleton.TOETIPSR]) = 1;
skeleton.linkchain(skeleton.FOOTR, [skeleton.TOESR skeleton.TOETIPSR]) = 1;
skeleton.linkchain(skeleton.TOESR , skeleton.TOETIPSR) = 1;

skeleton.linkchain(skeleton.UPPERLEGL, [skeleton.LOWERLEGL skeleton.FOOTL skeleton.TOESL skeleton.TOETIPSL]) = 1;
skeleton.linkchain(skeleton.LOWERLEGL, [skeleton.FOOTL skeleton.TOESL skeleton.TOETIPSL]) = 1;
skeleton.linkchain(skeleton.FOOTL, [skeleton.TOESL skeleton.TOETIPSL]) = 1;
skeleton.linkchain(skeleton.TOESL , skeleton.TOETIPSL) = 1;
%--------------------------------------------------------
skeleton.kinematicchain{1} = [skeleton.LOWERBACK skeleton.UPPERBACK skeleton.BASENECK ...
                               skeleton.UPPERARML skeleton.LOWERARML skeleton.HANDL skeleton.FINGERTIPSL];
skeleton.kinematicchain{2} = [skeleton.LOWERBACK skeleton.UPPERBACK skeleton.BASENECK ...
                                skeleton.UPPERARMR skeleton.LOWERARMR skeleton.HANDR skeleton.FINGERTIPSR];
skeleton.kinematicchain{3} = [skeleton.UPPERLEGL skeleton.LOWERLEGL skeleton.FOOTL skeleton.TOESL];
skeleton.kinematicchain{4} = [skeleton.UPPERLEGR skeleton.LOWERLEGR skeleton.FOOTR skeleton.TOESR];
skeleton.kinematicchain{5} = [skeleton.LOWERBACK skeleton.UPPERBACK skeleton.BASENECK skeleton.NECK skeleton.HEAD];
%--------------------------------------------------------
skeleton.jachain{1} = [31 34 37 40 43 46]; % pelvis-lowerback-upperback-lclavicle-lhumerus-lradius-lhand
skeleton.jachain{2} = [31 34 49 52 55 58]; % pelvis-lowerback-upperback-rclavicle-rhumerus-rradius-rhand
skeleton.jachain{3} = [7 10 13]; % pelvis-lfemur-ltibia-lfoot
skeleton.jachain{4} = [19 22 25]; % pelvis-rfemur-rtibia-rfoot
skeleton.jachain{5} = [31 34  61 64]; % pelvis-lowerback-upperback-lowerneck-neck
%--------------------------------------------------------
skeleton.NECKja = 61;
skeleton.LFOOTja = 13;
skeleton.LTOESja = 16;
skeleton.RFOOTja = 25;
skeleton.RTOESja = 28;
skeleton.LHANDja = 46;
skeleton.RHANDja = 58;
skeleton.PELVISja = 4;



