% The sequence of poses in 3d (seq3d) is interpolated to get a warped
% sequence.
% sourceseq = numFrames x (numDots*2)
% seq3d = numFrames x (numDots*3)
% a = 4x1 = time warp function. Takes a time t in the source sequence to a
% time tnew = [1 t t^2 t^3]*a , in seq3d.
% warpseq = numFrames x (numDots*3)
function [warpseq] = timewarp(sourceseq,seq3d,a)

numFrames = size(sourceseq,1);
warpseq = zeros(numFrames, size(seq3d,2));
for i=2:numFrames
   %tw = [1 i i^2 i^3]*a; 
   tw = [1 i i^2]*a; 
   t1 = floor(tw); w1 = abs(t1-tw);
   t2 = ceil(tw); w2 = abs(t2-tw); disp(tw)
   p1 = seq3d(t1,:);
   p2 = seq3d(t2,:);
   warpseq(i,:) = w2*p1 + w1*p2;
end